function getProfile() {
  liff
    .getProfile()
    .then(profile => {
      console.log(JSON.stringify(profile));
      window.alert(JSON.stringify(profile));
    })
    .catch(e => {
      console.log(e);
      window.alert(e);
    });
}
function getAccessToken() {
  window.alert(liff.getAccessToken());
}
function getContext() {
  window.alert(JSON.stringify(liff.getContext()));
}

function sendMessage() {
  liff
    .sendMessages([{ type: "text", text: "中文測試 Hello from LIFF2.0" }])
    .then(() => {
      window.alert("Message has been sent");
    })
    .catch(e => {
      window.alert(e);
    });
}

function login() {
  liff.login();
}

function scanCode() {
  liff
    .scanCode()
    .then(result => {
      window.alert(JSON.stringify(result));
    })
    .catch(e => {
      window.alert(e);
    });
}

function openWindow() {
  liff.openWindow({
    url: "https://line.me/1657386781-XARmDogn",
    external: true
  });
}

function closeWindow() {
  liff.closeWindow();
}

function logout() {
  if (liff.isLoggedIn()) {
    liff.logout();
    window.alert("Successfully to Logout");
    location.reload();
  }
}


// function createFlexMessageData() {
//   var flex = {
//     "type": "flex",
//     "altText": redistitle,
//     "contents": redisdata,
//   };

//   return flex;
// }

var _title = "MISA 向您分享了最新消息！";

function createFlexMessageData() {
  var myFlexContent = {
    "type": "bubble",
    "hero": {
      "type": "box",
      "layout": "vertical",
      "contents": [
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "text",
              "text": "MISA 沙龍小聚",
              "color": "#0E363E",
              "align": "center",
              "offsetTop": "3px",
              "size": "lg",
              "weight": "bold"
            }
          ],
          "paddingAll": "15px"
        },
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "image",
              "size": "full",
              "margin": "none",
              "url": "https://cmm.ai/img/MISA_0215.jpg",
              "offsetTop": "-10px"
            }
          ],
          "paddingStart": "5px",
          "paddingEnd": "5px",
          "height": "250px",
          "offsetTop": "-10px"
        }
      ]
    },
    "body": {
      "type": "box",
      "layout": "vertical",
      "contents": [
        {
          "type": "text",
          "text": "隨著疫情及氣候變遷對自然環境、",
          "weight": "bold",
          "size": "sm",
          "align": "center",
          "wrap": true,
          "margin": "none"
        },
        {
          "type": "text",
          "text": "社會及全球經濟產生嚴重影響",
          "weight": "bold",
          "size": "sm",
          "align": "center",
          "wrap": true,
          "margin": "sm"
        },
        {
          "type": "text",
          "text": "ESG 轉型風正在起飛",
          "weight": "bold",
          "size": "sm",
          "align": "center",
          "wrap": true,
          "margin": "sm"
        },
        {
          "type": "text",
          "text": "為了讓企業領導者",
          "weight": "bold",
          "size": "sm",
          "align": "center",
          "wrap": true,
          "margin": "sm"
        },
        {
          "type": "text",
          "text": "也能輕鬆參與 ESG 永續之路",
          "weight": "bold",
          "size": "sm",
          "align": "center",
          "wrap": true,
          "margin": "sm"
        },
        {
          "type": "separator",
          "margin": "xl"
        },
        {
          "type": "text",
          "text": "MISA 沙龍 2/15 日加開舉辦",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "xl"
        },
        {
          "type": "text",
          "text": "「ESG 浪潮來襲",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "sm"
        },
        {
          "type": "text",
          "text": "如何搶先佈局永續管理」",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "margin": "sm",
          "wrap": true
        },
        {
          "type": "text",
          "text": "解析 ESG 對企業經營",
          "weight": "bold",
          "size": "sm",
          "align": "center",
          "margin": "xl",
          "wrap": true
        },
        {
          "type": "text",
          "text": "即將面臨的重大轉折",
          "weight": "bold",
          "size": "sm",
          "align": "center",
          "margin": "sm",
          "wrap": true
        },
        {
          "type": "text",
          "text": "以及如何搶先布局",
          "weight": "bold",
          "size": "sm",
          "align": "center",
          "margin": "sm",
          "wrap": true
        },
        {
          "type": "separator",
          "margin": "xl"
        },
        {
          "type": "text",
          "text": "日期：2023/02/15（三）",
          "weight": "bold",
          "size": "sm",
          "align": "center",
          "margin": "xl",
          "wrap": true
        },
        {
          "type": "text",
          "text": "時間：19:00～20:30（18:45報到）",
          "weight": "bold",
          "size": "sm",
          "align": "center",
          "margin": "sm",
          "wrap": true
        },
        {
          "type": "text",
          "text": "地點：MISA 智享會 (台北市內湖區洲子街12號4樓，內湖運動中心)",
          "weight": "bold",
          "size": "sm",
          "align": "center",
          "margin": "sm",
          "wrap": true
        }
      ],
      "offsetTop": "-15px"
    },
    "footer": {
      "type": "box",
      "layout": "vertical",
      "spacing": "sm",
      "contents": [
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "button",
              "style": "link",
              "height": "sm",
              "action": {
                "type": "uri",
                "label": "報名參加",
                "uri": "https://s.aiii.ai/g/f8db1f"
              },
              "color": "#ffffff"
            }
          ],
          "backgroundColor": "#0E363E",
          "cornerRadius": "md"
        },
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "button",
              "style": "link",
              "height": "sm",
              "action": {
                "type": "uri",
                "label": "活動分享",
                "uri": "https://liff.googo.org/misa-0215/?openInAppBrowser=1&openExternalBrowser=1"
              },
              "color": "#0E363E"
            }
          ],
          "cornerRadius": "md",
          "margin": "lg",
          "borderColor": "#0E363E",
          "borderWidth": "normal"
        },
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "button",
              "style": "link",
              "height": "sm",
              "action": {
                "type": "uri",
                "label": "官方網站",
                "uri": "https://www.misaglobal.org/"
              },
              "color": "#0E363E"
            }
          ],
          "cornerRadius": "md",
          "margin": "lg",
          "borderColor": "#0E363E",
          "borderWidth": "normal"
        },
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "image",
              "url": "https://static.kolable.com/images/misa/logo.png/120?v=1641520480847"
            }
          ],
          "margin": "none",
          "position": "absolute",
          "offsetStart": "108px",
          "offsetTop": "130px"
        }
      ],
      "flex": 0,
      "height": "200px"
    }
  };

  var flex = {
    "type": "flex",
    "altText": _title,
    "contents": myFlexContent,
  };

  return flex;
}

var redisdata = '';

function shareTargetPicker() {

  liff.shareTargetPicker([
    createFlexMessageData()
  ])
    .then(function (res) {
      if (res) {
        // succeeded in sending a message through TargetPicker
        console.log(`[${res.status}] Message sent!`)
      } else {
        const [majorVer, minorVer] = (liff.getLineVersion() || "").split('.');
        if (parseInt(majorVer) == 10 && parseInt(minorVer) < 11) {
          // LINE 10.3.0 - 10.10.0
          // Old LINE will access here regardless of user's action
          console.log('TargetPicker was opened at least. Whether succeeded to send message is unclear')
        } else {
          // LINE 10.11.0 -
          // sending message canceled
          console.log('TargetPicker was closed!')
        }
      }
    }).catch(function (error) {
      // something went wrong before sending a message
      console.log('something wrong happen', error)
    })

  // const url = 'https://liff.googo.org:9898/misa-liff'
  // axios
  //   .get(url)
  //   .then(({data}) => {
  //     redisdata=data.data;
  //     redistitle=data.title;
  //     console.log(redistitle);
  //     console.log(redisdata);

  //     liff.shareTargetPicker([
  //       {
  //         type: "text",
  //         text: "Test!"
  //       }
  //     ])
  //       .then(
  //         console.log("ShareTargetPicker was launched")
  //       ).catch(function (res) {
  //         alert(res);
  //         console.log("Failed to launch ShareTargetPicker", res)
  //       })

  //     // liff
  //     // .shareTargetPicker([
  //     //   createFlexMessageData()      
  //     // ])
  //     // .then(() => {
  //     //   alert("Shared to the friend(s) you picked");
  //     // })
  //     // .catch(function(res) {
  //     //   alert(res);
  //     // });

  //   });
}
