function getProfile() {
  liff
    .getProfile()
    .then(profile => {
      console.log(JSON.stringify(profile));
      window.alert(JSON.stringify(profile));
    })
    .catch(e => {
      console.log(e);
      window.alert(e);
    });
}
function getAccessToken() {
  window.alert(liff.getAccessToken());
}
function getContext() {
  window.alert(JSON.stringify(liff.getContext()));
}

function sendMessage() {
  liff
    .sendMessages([{ type: "text", text: "中文測試 Hello from LIFF2.0" }])
    .then(() => {
      window.alert("Message has been sent");
    })
    .catch(e => {
      window.alert(e);
    });
}

function login() {
  liff.login();
}

function scanCode() {
  liff
    .scanCode()
    .then(result => {
      window.alert(JSON.stringify(result));
    })
    .catch(e => {
      window.alert(e);
    });
}

function openWindow() {
  liff.openWindow({
    url: "https://line.me/1657386781-XARmDogn",
    external: true
  });
}

function closeWindow() {
  liff.closeWindow();
}

function logout() {
  if (liff.isLoggedIn()) {
    liff.logout();
    window.alert("Successfully to Logout");
    location.reload();
  }
}


// function createFlexMessageData() {
//   var flex = {
//     "type": "flex",
//     "altText": redistitle,
//     "contents": redisdata,
//   };

//   return flex;
// }

var _title = "MISA 向您分享了最新消息！";

function createFlexMessageData() {
  var myFlexContent = {
    "type": "bubble",
    "hero": {
      "type": "box",
      "layout": "vertical",
      "contents": [
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "text",
              "text": "缺工浪潮來襲",
              "color": "#f39a00",
              "align": "center",
              "offsetTop": "3px",
              "size": "lg",
              "weight": "bold"
            },
            {
              "type": "text",
              "text": "全球掀起人才保衛戰",
              "color": "#f39a00",
              "align": "center",
              "offsetTop": "3px",
              "size": "lg",
              "weight": "bold"
            }
          ],
          "paddingAll": "15px"
        },
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "image",
              "size": "full",
              "margin": "none",
              "url": "https://imgur.com/5Dqezpb.jpg",
              "offsetTop": "-0px"
            }
          ],
          "paddingStart": "5px",
          "paddingEnd": "5px",
          "height": "210px"
        }
      ]
    },
    "body": {
      "type": "box",
      "layout": "vertical",
      "contents": [
        {
          "type": "text",
          "text": "「留才」",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "lg"
        },
        {
          "type": "text",
          "text": "是企業經營非常重要的培育藍圖",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "sm"
        },
        {
          "type": "separator",
          "margin": "lg"
        },
        {
          "type": "text",
          "text": "重視員工、儲備人才",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "lg"
        },
        {
          "type": "text",
          "text": "並且願意將資源分享給每位員工",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "sm"
        },
        {
          "type": "text",
          "text": "平時藉由考核機會與員工作心談",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "sm"
        },
        {
          "type": "text",
          "text": "了解員工的想法",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "sm"
        },
        {
          "type": "text",
          "text": "幫助員工解決工作上遇到的難題",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "sm"
        },
        {
          "type": "text",
          "text": "考核不能流於形式，只注重分數。",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "margin": "sm",
          "wrap": true
        }
      ],
      "offsetTop": "-10px"
    },
    "footer": {
      "type": "box",
      "layout": "vertical",
      "spacing": "sm",
      "contents": [
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "button",
              "style": "link",
              "height": "sm",
              "action": {
                "type": "uri",
                "label": "立即上課",
                "uri": "https://www.misaglobal.org/program-packages/52fe849d-84c2-4b99-97f7-c24878a4d3af"
              },
              "color": "#ffffff"
            }
          ],
          "backgroundColor": "#f39a00",
          "cornerRadius": "md"
        },
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "button",
              "style": "link",
              "height": "sm",
              "action": {
                "type": "uri",
                "label": "活動分享",
                "uri": "https://liff.googo.org/misa-program-3/?openInAppBrowser=1&openExternalBrowser=1"
              },
              "color": "#f39a00"
            }
          ],
          "cornerRadius": "md",
          "margin": "lg",
          "borderColor": "#f39a00",
          "borderWidth": "normal"
        },
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "button",
              "style": "link",
              "height": "sm",
              "action": {
                "type": "uri",
                "label": "10 分鐘精華",
                "uri": "https://www.youtube.com/watch?v=O27PYwI1ri0&t=15s"
              },
              "color": "#f39a00"
            }
          ],
          "cornerRadius": "md",
          "margin": "lg",
          "borderColor": "#f39a00",
          "borderWidth": "normal"
        },
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "image",
              "url": "https://static.kolable.com/images/misa/logo.png/120?v=1641520480847"
            }
          ],
          "margin": "none",
          "position": "absolute",
          "offsetStart": "108px",
          "offsetTop": "135px"
        }
      ],
      "flex": 0,
      "height": "195px",
      "offsetTop": "-10px"
    }
  };

  var flex = {
    "type": "flex",
    "altText": _title,
    "contents": myFlexContent,
  };

  return flex;
}

var redisdata = '';

function shareTargetPicker() {

  liff.shareTargetPicker([
    createFlexMessageData()
  ])
    .then(function (res) {
      if (res) {
        // succeeded in sending a message through TargetPicker
        console.log(`[${res.status}] Message sent!`)
      } else {
        const [majorVer, minorVer] = (liff.getLineVersion() || "").split('.');
        if (parseInt(majorVer) == 10 && parseInt(minorVer) < 11) {
          // LINE 10.3.0 - 10.10.0
          // Old LINE will access here regardless of user's action
          console.log('TargetPicker was opened at least. Whether succeeded to send message is unclear')
        } else {
          // LINE 10.11.0 -
          // sending message canceled
          console.log('TargetPicker was closed!')
        }
      }
    }).catch(function (error) {
      // something went wrong before sending a message
      console.log('something wrong happen', error)
    })

  // const url = 'https://liff.googo.org:9898/misa-liff'
  // axios
  //   .get(url)
  //   .then(({data}) => {
  //     redisdata=data.data;
  //     redistitle=data.title;
  //     console.log(redistitle);
  //     console.log(redisdata);

  //     liff.shareTargetPicker([
  //       {
  //         type: "text",
  //         text: "Test!"
  //       }
  //     ])
  //       .then(
  //         console.log("ShareTargetPicker was launched")
  //       ).catch(function (res) {
  //         alert(res);
  //         console.log("Failed to launch ShareTargetPicker", res)
  //       })

  //     // liff
  //     // .shareTargetPicker([
  //     //   createFlexMessageData()      
  //     // ])
  //     // .then(() => {
  //     //   alert("Shared to the friend(s) you picked");
  //     // })
  //     // .catch(function(res) {
  //     //   alert(res);
  //     // });

  //   });
}
