function getProfile() {
  liff
    .getProfile()
    .then(profile => {
      console.log(JSON.stringify(profile));
      window.alert(JSON.stringify(profile));
    })
    .catch(e => {
      console.log(e);
      window.alert(e);
    });
}
function getAccessToken() {
  window.alert(liff.getAccessToken());
}
function getContext() {
  window.alert(JSON.stringify(liff.getContext()));
}

function sendMessage() {
  liff
    .sendMessages([{ type: "text", text: "中文測試 Hello from LIFF2.0" }])
    .then(() => {
      window.alert("Message has been sent");
    })
    .catch(e => {
      window.alert(e);
    });
}

function login() {
  liff.login();
}

function scanCode() {
  liff
    .scanCode()
    .then(result => {
      window.alert(JSON.stringify(result));
    })
    .catch(e => {
      window.alert(e);
    });
}

function openWindow() {
  liff.openWindow({
    url: "https://line.me/1657386781-XARmDogn",
    external: true
  });
}

function closeWindow() {
  liff.closeWindow();
}

function logout() {
  if (liff.isLoggedIn()) {
    liff.logout();
    window.alert("Successfully to Logout");
    location.reload();
  }
}


// function createFlexMessageData() {
//   var flex = {
//     "type": "flex",
//     "altText": redistitle,
//     "contents": redisdata,
//   };

//   return flex;
// }

var _title = "MISA 向您分享了最新消息！";

function createFlexMessageData() {
  var myFlexContent = {
    "type": "bubble",
    "hero": {
      "type": "box",
      "layout": "vertical",
      "contents": [
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "text",
              "text": "有貪婪老闆，必有貪污員工",
              "color": "#f39a00",
              "align": "center",
              "offsetTop": "3px",
              "size": "lg",
              "weight": "bold"
            }
          ],
          "paddingAll": "15px"
        },
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "image",
              "size": "full",
              "margin": "none",
              "url": "https://imgur.com/r8w9gsF.jpg",
              "offsetTop": "-10px"
            }
          ],
          "paddingStart": "5px",
          "paddingEnd": "5px",
          "height": "190px"
        }
      ]
    },
    "body": {
      "type": "box",
      "layout": "vertical",
      "contents": [
        {
          "type": "text",
          "text": "老闆的道德標準",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "sm"
        },
        {
          "type": "text",
          "text": "是員工道德標準的上限",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "sm"
        },
        {
          "type": "text",
          "text": "絕對是公司每個人的「榜樣」",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "sm"
        },
        {
          "type": "text",
          "text": "而身為老闆最好的態度是：",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "xxl"
        },
        {
          "type": "text",
          "text": "利益迴避，公私分明",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "sm"
        },
        {
          "type": "separator",
          "margin": "lg"
        },
        {
          "type": "text",
          "text": "城邦媒體 何飛鵬社長 用真實案例",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "lg"
        },
        {
          "type": "text",
          "text": "帶領你進入主管必修的私房學",
          "weight": "bold",
          "size": "md",
          "align": "center",
          "wrap": true,
          "margin": "sm"
        }
      ],
      "offsetTop": "-20px"
    },
    "footer": {
      "type": "box",
      "layout": "vertical",
      "spacing": "sm",
      "contents": [
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "button",
              "style": "link",
              "height": "sm",
              "action": {
                "type": "uri",
                "label": "立即上課",
                "uri": "https://www.misaglobal.org/program-packages/37397536-2d1e-44eb-b59a-fb0baa4646bf"
              },
              "color": "#ffffff"
            }
          ],
          "backgroundColor": "#f39a00",
          "cornerRadius": "md"
        },
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "button",
              "style": "link",
              "height": "sm",
              "action": {
                "type": "uri",
                "label": "活動分享",
                "uri": "https://liff.googo.org/misa-program-5/?openInAppBrowser=1&openExternalBrowser=1"
              },
              "color": "#f39a00"
            }
          ],
          "cornerRadius": "md",
          "margin": "lg",
          "borderColor": "#f39a00",
          "borderWidth": "normal"
        },
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "button",
              "style": "link",
              "height": "sm",
              "action": {
                "type": "uri",
                "label": "3 分鐘精華",
                "uri": "https://www.youtube.com/watch?v=hLGQN0qWDm0&t=7s"
              },
              "color": "#f39a00"
            }
          ],
          "cornerRadius": "md",
          "margin": "lg",
          "borderColor": "#f39a00",
          "borderWidth": "normal"
        },
        {
          "type": "box",
          "layout": "vertical",
          "contents": [
            {
              "type": "image",
              "url": "https://static.kolable.com/images/misa/logo.png/120?v=1641520480847"
            }
          ],
          "margin": "none",
          "position": "absolute",
          "offsetStart": "108px",
          "offsetTop": "135px"
        }
      ],
      "flex": 0,
      "height": "195px",
      "offsetTop": "-10px"
    }
  };

  var flex = {
    "type": "flex",
    "altText": _title,
    "contents": myFlexContent,
  };

  return flex;
}

var redisdata = '';

function shareTargetPicker() {

  liff.shareTargetPicker([
    createFlexMessageData()
  ])
    .then(function (res) {
      if (res) {
        // succeeded in sending a message through TargetPicker
        console.log(`[${res.status}] Message sent!`)
      } else {
        const [majorVer, minorVer] = (liff.getLineVersion() || "").split('.');
        if (parseInt(majorVer) == 10 && parseInt(minorVer) < 11) {
          // LINE 10.3.0 - 10.10.0
          // Old LINE will access here regardless of user's action
          console.log('TargetPicker was opened at least. Whether succeeded to send message is unclear')
        } else {
          // LINE 10.11.0 -
          // sending message canceled
          console.log('TargetPicker was closed!')
        }
      }
    }).catch(function (error) {
      // something went wrong before sending a message
      console.log('something wrong happen', error)
    })

  // const url = 'https://liff.googo.org:9898/misa-liff'
  // axios
  //   .get(url)
  //   .then(({data}) => {
  //     redisdata=data.data;
  //     redistitle=data.title;
  //     console.log(redistitle);
  //     console.log(redisdata);

  //     liff.shareTargetPicker([
  //       {
  //         type: "text",
  //         text: "Test!"
  //       }
  //     ])
  //       .then(
  //         console.log("ShareTargetPicker was launched")
  //       ).catch(function (res) {
  //         alert(res);
  //         console.log("Failed to launch ShareTargetPicker", res)
  //       })

  //     // liff
  //     // .shareTargetPicker([
  //     //   createFlexMessageData()      
  //     // ])
  //     // .then(() => {
  //     //   alert("Shared to the friend(s) you picked");
  //     // })
  //     // .catch(function(res) {
  //     //   alert(res);
  //     // });

  //   });
}
